<?php

namespace Drupal\commerce_stock_eca;

use Drupal\commerce\Context;
use Drupal\commerce_order\AvailabilityCheckerInterface;
use Drupal\commerce_order\AvailabilityResult;
use Drupal\commerce_order\Entity\OrderItemInterface;

/**
 * Class VariationAvailabilityChecker.
 */
class VariationAvailabilityChecker implements AvailabilityCheckerInterface {

  /**
   * {@inheritdoc}
   */
   public function applies(OrderItemInterface $order_item) {
     return TRUE;
   }

  /**
   * {@inheritdoc}
   */
  public function check(OrderItemInterface $order_item, Context $context) {
    $entity = $order_item->getPurchasedEntity();
//    if ($entity->field_eca_stock->value <= 0) {
//      return AvailabilityResult::unavailable('This product is out of stock.');
//    }
// field_eca_stock = Contain Stock Amount
// field_stock_always_available = in case we do not limit stock in this item
    if ($entity->field_eca_stock->value <= 0) {
      return AvailabilityResult::unavailable('This product is out of stock.');
    }
    return AvailabilityResult::neutral();
  }

}